{ AWCAPI.PAS WorkCenter API functions for Borland Delphi 1.0
  Copyright (C) EDM Consultants Limited, 1995, 1996
  Last modified M Hart, 19th January, 1996 Version 1.1b }

unit Awcapi;

interface

uses
  WinTypes;

const
 TDMFalse = 0;
 TDMTrue  = 1;

 TDMDefaultStringListSize = 0;
 TDMAttrListSizeDefault   = 0;
 TDMMaxStringLength       = 255;

 TDMAttrFlagValid = 1;
 TDMAttrFlagRead  = 2;
 TDMAttrFlagWrite = 4;

{ List Type constants - HLISTType in C }
 HLTHandleList   = 257; { list of handles }
 HLTStringList   = 258; { list of strings }
 HLTUsedDocTable = 259; { list of document types }

{ Relationship type object attribute constants - TDMRelTypeValues in C }
 TDMRTVStart      = 100;
 TDMRTVRelTypeID  = TDMRTVStart + 1; { ID }
 TDMRTVName 	  = TDMRTVStart + 2; { name }
 TDMRTVAppName    = TDMRTVStart + 3; { application that created the type }
 TDMRTVVisibility = TDMRTVStart + 4; { visibility }
 TDMRTVOrdered 	  = TDMRTVStart + 5; { order }
 TDMRTVType 	  = TDMRTVStart + 6; { type ? }
 TDMRTVEnd	  = TDMRTVStart + 7;

{ Specific enumerated relationship type constants - TDMRelTypeEnum in C }
 TDMRTEStart 	    = 100;
 TDMRTENone 	    = TDMRTEStart + 1;  { no relatioship }
 TDMRTEActiveDocs   = TDMRTEStart + 2;  { active doc (work req) }
 TDMRTEAttachedDocs = TDMRTEStart + 3;  { reference doc (work req) }
 TDMRTEToUsers 	    = TDMRTEStart + 4;  { users to whom wreq is sent }
 TDMRTECcUsers 	    = TDMRTEStart + 5;  { cc'ed wreq users }
 TDMRTEXRef 	    = TDMRTEStart + 6;  { AutoCAD xref }
 TDMRTEShx 	    = TDMRTEStart + 7;  { AutoCAD shx }
 TDMRTERedline 	    = TDMRTEStart + 8;  { redline }
 TDMRTEOLE 	    = TDMRTEStart + 9;  { OLE link }
 TDMRTESubscription = TDMRTEStart + 10; { subscription ??? }
 TDMRTESupportLink  = TDMRTEStart + 11; { support link ??? }
 TDMRTEEnd 	    = TDMRTEStart + 12;

{ Relationship object attribute constants - TDMRelValues in C }
 TDMRVStart	   = 200;
 TDMRVObjectID 	   = TDMRVStart + 1; { ID }
 TDMRVParentID     = TDMRVStart + 2; { parent ID }
 TDMRVChildID 	   = TDMRVStart + 3; { child ID }
 TDMRVRelTypeID    = TDMRVStart + 4; { relationship type ID }
 TDMRVComment 	   = TDMRVStart + 5; { description }
 TDMRVCreateDate   = TDMRVStart + 6; { date when relationship was created }
 TDMRVCreator 	   = TDMRVStart + 7; { user who created relationship }
 TDMRVCarryForward = TDMRVStart + 8; { TDMTrue if applies to future revs }
 TDMRVEnd 	   = TDMRVStart + 9;

{ Attribute object attribute constants - TDMAttrValues in C }
 TDMAVStart 	   = 300;
 TDMAVAttrID 	   = TDMAVStart + 1; { ID }
 TDMAVEnumeration  = TDMAVStart + 2; { fixed fields }
 TDMAVName 	   = TDMAVStart + 3; { name }
 TDMAVDefaultValue = TDMAVStart + 4; { default value }
 TDMAVMaxLength    = TDMAVStart + 5; { maximum length }
 TDMAVReadOnly 	   = TDMAVStart + 6; { TDMTrue if value cannot be modified }
 TDMAVType 	   = TDMAVStart + 7; { Text, List Text, etc. }
 TDMAVMandatory    = TDMAVStart + 8; { is field mandatory ? }
 TDMAVLookup 	   = TDMAVStart + 9; { TDMTrue if lookup }
 TDMAVEnd 	   = TDMAVStart + 10;

{ Specific enumerated attribute constants - TDMAttributeEnum in C }
 TDMAEStart		   = 300;
 TDMAEInvalid		   = TDMAEStart + 1;  { not used }
 TDMAEItemID		   = TDMAEStart + 2;  { Internal Doc ID }
 TDMAEVersionID            = TDMAEStart + 3;  { Internal Rev ID (this Rev) }
 TDMAEStatus		   = TDMAEStart + 4;  { Status }
 TDMAETitle		   = TDMAEStart + 5;  { Title (Doc Name ???) }
 TDMAECreateAuthor 	   = TDMAEStart + 6;  { Originator }
 TDMAECreateDate 	   = TDMAEStart + 7;  { Date Added }
 TDMAECreateComment 	   = TDMAEStart + 8;  { Note ??? }
 TDMAEDocumentType 	   = TDMAEStart + 9;  { Document Type }
 TDMAEOriginalFileName 	   = TDMAEStart + 10; { Original File Name }
 TDMAEDefaultFileName 	   = TDMAEStart + 11; { checkout fname ??? }
 TDMAECurrentVersionID 	   = TDMAEStart + 12; { Current Rev ID }
 TDMAECurrentVersionAuthor = TDMAEStart + 13; { Revisor (current Rev) ??? }
 TDMAEProcessStep	   = TDMAEStart + 14; { Design Phase }
 TDMAEVersionAuthor	   = TDMAEStart + 15; { Revisor (this Rev) ??? }
 TDMAEVersionName	   = TDMAEStart + 16; { Revision }
 TDMAEVersionComment	   = TDMAEStart + 17; { Revision Note ??? }
 TDMAEPath		   = TDMAEStart + 18; { Path }
 TDMAEBlocks		   = TDMAEStart + 19; { AutoCAD Blocks }
 TDMAEFileCategory	   = TDMAEStart + 20; { File Category }
 TDMAEEnd		   = TDMAEStart + 21;

{ User object value constants - TDMUserValues in C }
 TDMUVStart = 400;
 TDMUVName  = TDMUVStart + 1; { user name }
 TDMUVID    = TDMUVStart + 2; { ID }
 TDMUVEnd   = TDMUVStart + 3;

{ Group object attribute constants - TDMGroupValues in C }
 TDMGVStart = 500;
 TDMGVName  = TDMGVStart + 1; { group name }
 TDMGVid    = TDMGVStart + 2; { ID }
 TDMGVEnd   = TDMGVStart + 3;

{ Search object attribute constants - TDMSearchValues in C }
 TDMSVStart 	    = 600;
 TDMSVNumberQueries = TDMSVStart + 1; { number of queries in search }
 TDMSVMaxQueries    = TDMSVStart + 2; { total queries allowed in search }
 TDMSVEnd 	    = TDMSVStart + 3;

{ Error object attributes - TDMErrorValues in C }
 TDMEVStart = 700;
 TDMEVText  = TDMEVStart + 1; { error message - docs say 1 ??? }
 TDMEVCode  = TDMEVStart + 2; { error code - docs say 2 ??? }
 TDMEVEnd   = TDMEVStart + 3;

type

 TDMAPIHANDLE = longint;
 TDMAPILIST = integer;

{ Open File Structure }
 OPENFILENAME = record
  StructSize: longint;
  hWndOwner: Integer;
  hInstance: Integer;
  Filter: longint;         { string }
  CustomFilter: longint;   { string }
  MaxCustFilter: longint;
  FilterIndex: longint;
  FileName: longint;       { string }
  MaxFileName: longint;
  FileTitle: longint;      { string }
  MaxFileTitle: longint;
  InitialDir: longint;     { string }
  Title: longint;          { string }
  Flags: longint;          { string }
  FileOffset: Integer;
  FileExtension: Integer;
  DefExt: longint;         { string }
  CustData: longint;
  CallBack: Integer;
  TemplateName: longint;   { string }
 end;

{ Show Window modes }
 WinAPISWModes = (SW_HIDE,
 		  SW_MINIMIZE,
 		  SW_RESTORE,
 		  SW_SHOW,
 	 	  SW_SHOWMAXIMIZED,
       		  SW_SHOWMINIMIZED,
      		  SW_SHOWMINNOACTIVE,
 		  SW_SHOWNA,
 		  SW_SHOWNOACTIVE,
 		  SW_SHOWNORMAL);

{ Return codes }
 TDMAPIERROR = (TDMAPINotInitialized,
 	      	TDMAPIFailure,
 	      	TDMAPISuccess);

{ Open File Request Types }
 TDMAPIRqType = (RQTNone, 	    { current state }
	       	 RQTDesktop,        { workspace }
	       	 RQTDFV,            { Catalog }
	       	 RQTNewSearch,      { new search definition }
	       	 RQTNameSearch,     { search by title dialog }
       		 RQTAsk,            { not implemented }
     		 RQTRunGivenSearch, { run specified search }
    		 RQTGetParents,     { get parents of specified doc }
     		 RQTGetChildren,    { get children of specified doc }
     		 RQTGetRedlines);   { get redlines of specified doc }

{ Object Types }
 TDMAPIObject = (TDMODocument,         { documents }
	       	 TDMORelationshipType, { relationship type }
	       	 TDMORelationship,     { relationship }
	       	 TDMOAttribute,        { field }
	       	 TDMOGroup,            { user group }
	       	 TDMOUser,             { user }
	       	 TDMOSearch,           { MAY BE WRONG !!!! }
	       	 TDMOError,            { MAY BE WRONG !!!! }
	       	 TDMONumberObjects);   { MAY BE WRONG !!!! }

{ Document object attributes }
 TDMDocValues = (TDMDVStart,
	       	 TDMDVTitle,                     { title ??? }
	       	 TDMDVDocID,                     { ID }
	       	 TDMDVVersion,                   { this revision name ??? }
	       	 TDMDVComment,                   { description ??? }
	       	 TDMDVOriginalFileName,          { original file name }
	       	 TDMDVIsApproved,                { =1 if so, else =0 }
	       	 TDMDVIsCheckedOut,              { =1 if so, else =0 }
	       	 TDMDVIsCheckedOutToCurrentUser, { =1 if so, else =0 }
	       	 TDMDVProcessStep,               { design phase }
	       	 TDMDVDocumentType,              { document type }
	       	 TDMDVStatus,                    { ChkIn, ChkOut or Approved }
	       	 TDMDVPath,                      { location if in workspace }
	       	 TDMDVNextVersionName,           { next doc revision ??? }
	       	 TDMDVConvertFileName,         { template fnam => doc fnam ??? }
	       	 TDMDVRevisionName,              { current rev name (doc) ??? }
	       	 TDMDVCreateComment,             { create comment field ??? }
	       	 TDMDVVaultPath,                 { direct shelf path }
	       	 TDMDVEnd);

{ Rev Types used for getting next Revision name }
 TDMDRevType = (TDMDRTPoint,     { next rev name }
  	      	TDMDRTBranch,    { branched rev name }
	      	TDMDRTApprove,   { rev name for approval }
	      	TDMDRTMerge,     { rev name for merge branch }
	      	TDMDRTCheckin,   { rev name for checkin }
	      	TDMDRTCheckout); { rev name for checkout }

{ Relationship operations for searches }
 TDMAPIRelOp = (TRO_EQ,  { = }
	      	TRO_GE,  { >= }
	      	TRO_GT,  { > }
	      	TRO_LE,  { <= }
	      	TRO_LK,  { like (wild card) }
	      	TRO_LT,  { < }
	      	TRO_NE,  { <> }
	      	TRO_NL); { not like (wild card) }

{ And / Or conditions for searches }
 TDMAPIAndOrStop = (TAOSStart, { start of compound statement }
		    TAOSStop,  { end of compound statement }
		    TAOSAnd,   { AND condition }
		    TAOSOr);   { OR condition }

{ Server errors }
 TDMAPIServerError = (TDMAPISESuccess,          { no error }
 		      TDMAPISETDMFailure,       { unspecified error }
 		      TDMAPISEInvalidHandle,    { handle was invalid }
 		      TDMAPISEInvalidParam,     { API DLL calling error }
 		      TDMAPISECantAllocMem,     { memory error }
 		      TDMAPISEAttrNotSettable,  { user cannot change the field }
 		      TDMAPISETDMNotReady);     { undocumented }

{ Client errors }
 TDMAPIClientError = (TDMAPICESuccess,               { no error }
 		      TDMAPICECantAllocMem,          { memory error }
 		      TDMAPICECannotConnectToServer, { communication error }
 		      TDMAPICEInvalidServerVersion,  { client incompatible
                                                       version to server }
 		      TDMAPICEInvalidServerResponse, { comm syntax error }
 		      TDMAPICEInvalidParam,          { API DLL calling error }
 		      TDMAPICEBufferTooSmall,        { stg too small for value }
 		      TDMAPICEInvalidHandle,         { handle was invalid }
 		      TDMAPICEInvalidList,           { list handle was invalid }
 		      TDMAPICEInvalidIndex,          { list member invalid }
		      TDMAPICEAPINotInitialized,     { undocumented }
		      TDMAPICETooManyHandles,        { undocumented }
		      TDMAPICENetworkNotAvailable);  { undocumented }


{ AWCAPI function declarations }

{ Startup functions }
function TDM_DetectTDM: Boolean;        { useless function }
function TDM_IsAPIInitialized: Boolean; { useless function }
function TDM_InitializeAPI: TDMAPIERROR;{OK}
function TDM_ShowTDM (mode: WinAPISWModes): TDMAPIERROR;{OK}
function TDM_GetServerID (strID: PChar; lenID: word): TDMAPIERROR;{OK}
function TDM_GetVersion (Ver: PChar; lenVer: word): word;{OK}
function TDM_TerminateAPI: TDMAPIERROR;{OK}

{ General object functions }
function TDM_GetHandleFromEnumeration (objectType: TDMAPIObject; enumVal: word;
         var lpHandle: TDMAPIHANDLE): TDMAPIERROR;{OK}
function TDM_GetHandleFromID (objectType: TDMAPIObject; objectId: PChar;
         var phandle: TDMAPIHANDLE): TDMAPIERROR;{OK}
function TDM_GetHandleFromName (objectType: TDMAPIObject; objectName: PChar;
         var pHandle: TDMAPIHANDLE): TDMAPIERROR;{OK}
function TDM_GetValue (objectType: TDMAPIObject; field: word; handle:
         TDMAPIHANDLE; pValue: PChar; valueLength: word): TDMAPIERROR;{OK}
function TDM_IsValidHandle (handle: TDMAPIHANDLE): Boolean;{OK}
function TDM_ReleaseHandle (handle: TDMAPIHANDLE): TDMAPIERROR;{OK}
function TDM_ReleaseAllHandles: TDMAPIERROR;{OK}
function TDM_DeleteObject (handle: TDMAPIHANDLE): TDMAPIERROR;{OK}
function TDM_SetValue (objectType: TDMAPIObject; field: word; handle:
         TDMAPIHANDLE; pValue: PChar): TDMAPIERROR;{OK}

function TDM_ReloadObject (handle: TDMAPIHANDLE): TDMAPIERROR;
function TDM_SaveObject (handle: TDMAPIHANDLE): TDMAPIERROR;{OK}

{ Functions for the document object }
function TDM_GetDesktopHandles (var pList: TDMAPILIST): TDMAPIERROR;{OK}
function TDM_GetLatestVersion (docId: PChar; bRevRule: Boolean;
         var hDoc: TDMAPIHANDLE): TDMAPIERROR;
function TDM_UpdateDesktop (hDoc: TDMAPIHANDLE; bDeleteFile: Boolean)
         : TDMAPIERROR;
function TDM_RemoveFromDesktop (hDoc: TDMAPIHANDLE; bDeleteFile: Boolean)
         : TDMAPIERROR;
function TDM_Import (pPath: PChar; bDeleteFile, bScan: Boolean; hUser, group:
         TDMAPIHANDLE; pFileCat: PChar; pHandle: TDMAPIHANDLE): TDMAPIERROR;
function TDM_CreateDocument (hUser, hGroup: TDMAPIHANDLE; var hDoc:
         TDMAPIHANDLE): TDMAPIERROR;{OK}
function TDM_Checkout (hDoc: TDMAPIHANDLE; pPath: PChar; bOverWrite: Boolean)
         : TDMAPIERROR;
function TDM_CancelCheckout (dDoc: TDMAPIHANDLE; bDeleteFile: Boolean)
         : TDMAPIERROR;{OK}
function TDM_Copyout (hDoc: TDMAPIHANDLE; dir: PChar; bOverWrite: Boolean)
         : TDMAPIERROR;
function TDM_Checkin (hDoc: TDMAPIHANDLE; pPath: PChar; bDeleteFile,
         bScan: Boolean): TDMAPIERROR;{OK}
function TDM_Approve (hDoc: TDMAPIHANDLE): TDMAPIERROR;{OK}
function TDM_GetVersionHandles (hDoc: TDMAPIHANDLE; var pList: TDMAPILIST)
         : TDMAPIERROR;
function TDM_GetNextVersionName (hDoc: TDMAPIHANDLE; RevType: TDMDRevType;
         pNextRevisionName: PChar; count: word): TDMAPIERROR;
function TDM_GetRelationshipHandles (hDoc, hRelType: TDMAPIHANDLE; bGetParents,
         bFstLevelOnly: Boolean; var pList: TDMAPILIST): TDMAPIERROR;
function TDM_GetUsedDocumentTable (hDoc: TDMAPIHANDLE; var pTable: TDMAPILIST)
         : TDMAPIERROR;

{ Functions for the attribute object }
function TDM_GetAttributeHandles (hDoc: TDMAPIHANDLE; var pList: TDMAPILIST)
         : TDMAPIERROR;
function TDM_GetAttributeFlags(hDoc, field: TDMAPIHANDLE; var flags: word)
         : TDMAPIERROR;{OK}
function TDM_GetAttributeValueList (field: TDMAPIHANDLE; nMaxItems: word;
         var pList: TDMAPILIST): TDMAPIERROR;
function TDM_GetAttributeValue (hDoc, field: TDMAPIHANDLE; pValue: PChar;
         valueLength: word): TDMAPIERROR;{OK}
function TDM_VerifyAttributeValue (field: TDMAPIHANDLE; value: PChar;
         var isValid: Boolean): TDMAPIERROR;{OK}
function TDM_SetAttributeValue (hDoc, field: TDMAPIHANDLE; pValue: PChar)
         : TDMAPIERROR;{OK}
function TDM_GetMultiValue (hDoc, field: TDMAPIHANDLE; var lpList: TDMAPILIST)
         : TDMAPIERROR;
function TDM_SetMultiValue (hDoc, field: TDMAPIHANDLE; var lpList: TDMAPILIST)
         : TDMAPIERROR;

{ Functions for the relationship Type Object }
function TDM_CreateRelationshipType (pName: PChar; var pRelType: TDMAPIHANDLE)
         : TDMAPIERROR;{OK}                                                {OK}
function TDM_GetRelationshipTypeHandles (var pList: TDMAPILIST): TDMAPIERROR;

{ Functions for the relationship object }
function TDM_CreateRelationship (hParent, hChild, hRelnType: TDMAPIHANDLE;
         var pRelationship: TDMAPIHANDLE): TDMAPIERROR;{OK}

{ Functions for the Group Object }
function TDM_GetGroupHandles (var pList: TDMAPILIST): TDMAPIERROR;

{ Functions for the User Object }
function TDM_GetUserHandles (var pList: TDMAPILIST): TDMAPIERROR;
function TDM_IsCurrentUserAdmin (var IsAdmin: Boolean): TDMAPIERROR;{OK}

{ Functions for the Search Object }
function TDM_CreateSearch (var lpHandle: TDMAPIHANDLE): TDMAPIERROR;
function TDM_AddQuery (hSrch, field: TDMAPIHANDLE; RelOp: TDMAPIRelOp;
	 AndOrStop: TDMAPIAndOrStop; nesting: word; value: PChar) : TDMAPIERROR;
function TDM_GetSearchResult (hSrch: TDMAPIHANDLE; var lpDocuments: TDMAPILIST)
         : TDMAPIERROR;

{ Functions that Provide User Interface }
function TDM_OpenFile (var OFN: OPENFILENAME; rt: TDMAPIRqType; handle1,
         handle2: TDMAPIHANDLE; var bCancel: Boolean; var bShowFile: Boolean;
         var lphList: TDMAPILIST): TDMAPIERROR;
function TDM_GetSaveAsDocument (var OFN: OPENFILENAME; var bCancel: Boolean;
         var bShowFile: Boolean; var lpDoc: TDMAPIHANDLE): TDMAPIERROR;

{ List functions }
function TDM_DeleteList (list: TDMAPILIST; bRelElementHandles: Boolean)
         : TDMAPIERROR;{OK}
function TDM_ClearStringList (lpList: TDMAPILIST): TDMAPIERROR;
function TDM_GetListSize (list: TDMAPILIST; var pSize: word): TDMAPIERROR;{OK}
function TDM_IsValidList (list: TDMAPILIST): Boolean;{OK}
function TDM_GetHandleListElement (list: TDMAPILIST; index: word;
	 var pHandle: TDMAPIHANDLE): TDMAPIERROR;{OK}
function TDM_CreatestringList (var lpList: TDMAPILIST; nElements: word)
         : TDMAPIERROR;
function TDM_AddStringListElement (var lpList: TDMAPILIST; value: PChar)
         : TDMAPIERROR;
function TDM_GetStringListElement (list: TDMAPILIST; index: word;
   	 pstring: PChar; stringLength: word): TDMAPIERROR;
function TDM_SetStringListElement (hList: TDMAPILIST; nIndex: word;
         value: PChar): TDMAPIERROR;
function TDM_GetUDTRow (table: TDMAPILIST; index: word; hDoc: TDMAPIHANDLE;
         pOldPath: PChar; oldPathLength: word; pNewPath: PChar;
         newPathLength: word; var RelationshipType: word): TDMAPIERROR;

{ Error Handling Helper functions }
function TDM_GetTDMErrorHandle: word;
function TDM_GetServerError: TDMAPIServerError;
function TDM_GetClientError: TDMAPIClientError;
function TDM_GetErrorstring (buffer: PChar; szBuffer: word): TDMAPIERROR;
function IsOkay (err: TDMAPIERROR) : Boolean;{OK}

implementation

{ AWCAPI function definitions }

{ Startup functions }
function TDM_InitializeAPI    ; external 'AWCAPI';
function TDM_DetectTDM        ; external 'AWCAPI';
function TDM_TerminateAPI     ; external 'AWCAPI';
function TDM_IsAPIInitialized ; external 'AWCAPI';
function TDM_GetVersion       ; external 'AWCAPI';
function TDM_ShowTDM          ; external 'AWCAPI';
function TDM_GetServerID      ; external 'AWCAPI';

{ General object functions }
function TDM_ReleaseAllHandles        ; external 'AWCAPI';
function TDM_GetHandleFromID          ; external 'AWCAPI';
function TDM_GetHandleFromName        ; external 'AWCAPI';
function TDM_GetHandleFromEnumeration ; external 'AWCAPI';
function TDM_IsValidHandle            ; external 'AWCAPI';
function TDM_ReleaseHandle            ; external 'AWCAPI';
function TDM_DeleteObject             ; external 'AWCAPI';
function TDM_GetValue                 ; external 'AWCAPI';
function TDM_SetValue                 ; external 'AWCAPI';
function TDM_ReloadObject             ; external 'AWCAPI';
function TDM_SaveObject               ; external 'AWCAPI';

{ Functions for the document object }
function TDM_GetDesktopHandles      ; external 'AWCAPI';
function TDM_GetLatestVersion       ; external 'AWCAPI';
function TDM_UpdateDesktop          ; external 'AWCAPI';
function TDM_RemoveFromDesktop      ; external 'AWCAPI';
function TDM_Import                 ; external 'AWCAPI';
function TDM_CreateDocument         ; external 'AWCAPI';
function TDM_Checkout               ; external 'AWCAPI';
function TDM_CancelCheckout         ; external 'AWCAPI';
function TDM_Copyout                ; external 'AWCAPI';
function TDM_Checkin                ; external 'AWCAPI';
function TDM_Approve                ; external 'AWCAPI';
function TDM_GetVersionHandles      ; external 'AWCAPI';
function TDM_GetNextVersionName     ; external 'AWCAPI';
function TDM_GetRelationshipHandles ; external 'AWCAPI';
function TDM_GetUsedDocumentTable   ; external 'AWCAPI';

{ Functions for the attribute object }
function TDM_GetAttributeHandles   ; external 'AWCAPI';
function TDM_GetAttributeFlags     ; external 'AWCAPI';
function TDM_GetAttributeValueList ; external 'AWCAPI';
function TDM_GetAttributeValue     ; external 'AWCAPI';
function TDM_VerifyAttributeValue  ; external 'AWCAPI';
function TDM_SetAttributeValue     ; external 'AWCAPI';
function TDM_GetMultiValue         ; external 'AWCAPI';
function TDM_SetMultiValue         ; external 'AWCAPI';

{ Functions for the relationship Type Object }
function TDM_CreateRelationshipType     ; external 'AWCAPI';
function TDM_GetRelationshipTypeHandles ; external 'AWCAPI';

{ Functions for the relationship object }
function TDM_CreateRelationship ; external 'AWCAPI';

{ Functions for the Group Object }
function TDM_GetGroupHandles ; external 'AWCAPI';

{ Functions for the User Object }
function TDM_GetUserHandles     ; external 'AWCAPI';
function TDM_IsCurrentUserAdmin ; external 'AWCAPI';

{ Functions for the Search Object }
function TDM_CreateSearch    ; external 'AWCAPI';
function TDM_AddQuery        ; external 'AWCAPI';
function TDM_GetSearchResult ; external 'AWCAPI';

{ Functions that Provide User Interface }
function TDM_OpenFile          ; external 'AWCAPI';
function TDM_GetSaveAsDocument ; external 'AWCAPI';

{ List functions }
function TDM_DeleteList           ; external 'AWCAPI';
function TDM_ClearstringList      ; external 'AWCAPI';
function TDM_GetListSize          ; external 'AWCAPI';
function TDM_IsValidList          ; external 'AWCAPI';
function TDM_GetHandleListElement ; external 'AWCAPI';
function TDM_CreatestringList     ; external 'AWCAPI';
function TDM_AddstringListElement ; external 'AWCAPI';
function TDM_GetstringListElement ; external 'AWCAPI';
function TDM_SetstringListElement ; external 'AWCAPI';
function TDM_GetUDTRow            ; external 'AWCAPI';

{ Error Handling Helper functions }
function TDM_GetTDMErrorHandle ; external 'AWCAPI';
function TDM_GetServerError    ; external 'AWCAPI';
function TDM_GetClientError    ; external 'AWCAPI';
function TDM_GetErrorstring    ; external 'AWCAPI';
function IsOkay;
 begin
  Result := (err = TDMAPISuccess);
 end;

end.
